_eps = 1e-4;
_inf = 1e4;
_inf2 = 2 * _inf;

$fn = 32;

module dilate(r) {
	if (r > 0) {
		minkowski() {
			circle(r);
			union() {
				children();
			}
		}
	} else if (r < 0) {
		difference() {
			square(_inf, center = true);
			
			erode(r) {
				difference() {
					square(_inf2, center = true);
					children();
				}
			}
		}
	} else {
		children();
	}
}

module erode(r) {
	dilate(-r) {
		children();
	}
}

module closing(r) {
	erode(r) {
		dilate(r) {
			children();
		}
	}
}

module opening(r) {
	closing(-r) {
		children();
	}
}

module border(d) {
	difference() {
		children();
		
		erode(d) {
			children();
		}	
	}
}

render() {
	border(2) {
		union() {
			polygon([[0, 0], [10, 0], [20, 20], [0, 10]]);
			circle(5);
		}
	}
}
